<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xalan="http://xml.apache.org/xslt" xmlns:portal="http://www.ibm.com/websphere/appserver/schemas/6.0/ibm-portal-topology.xsd" xmlns:base="http://www.ibm.com/websphere/appserver/schemas/6.0/ibm-portal-base.xsd" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" exclude-result-prefixes="portal base">
	<xsl:output method="xml" encoding="UTF-8" indent="yes" xalan:indent-amount="2" />

	<xsl:strip-space elements="*" />

	<!--======================================================================-->
	<!-- This file contains an XSLT transformation stylesheet which           -->
	<!-- constructs a result tree from a number of XML sources by filtering   -->
	<!-- reordering and adding arbitrary structure. This file is              -->
	<!-- automatically generated by the XML Mapper tool from IBM WebSphere    -->
	<!-- Studio Workbench.                                                    -->
	<!--======================================================================-->

	<!--======================================================================-->
	<!--              XML Sources (For Multiple Sources ONLY)                 -->
	<!-- The "XML Sources" section accomplishes two things: it specifies the  -->
	<!-- input XML sources and relates the root node of each source to a      -->
	<!-- global variable for access throughout the stylesheet.                -->
	<!--                                                                      -->
	<!-- Note for multiple XML sources, all sources must be specified using   -->
	<!-- the stylesheet parameters "document1", "document2", "document3" etc. -->
	<!--======================================================================-->

	<xsl:param name="content-root" select="'wps.My Portal'" />
	<xsl:param name="portaledit-xml" />
	<xsl:param name="localportlet-xml" />
	<xsl:param name="dummyportlet-web-app-uid" />
	<xsl:param name="dummyportlet-portlet-app-uid" />
	<xsl:param name="dummyportlet-portlet-name" />
	<xsl:param name="source-uri" select="/" />
	<xsl:param name="oids-creation" select="'false'" />
	<xsl:param name="themesandskinsonly" select="'false'" />
	<xsl:param name="nolayoutuniquename" select="'false'" />

	<!--======================================================================-->
	<!--                          The Root Element                            -->
	<!-- The "Root Element" section specifies which template will be          -->
	<!-- invoked first thus determining the root element of the result tree.  -->
	<!--======================================================================-->
	<xsl:template match="/">
		<!-- request -->
		<xsl:apply-templates select="portal:ibm-portal-topology" />
	</xsl:template>

	<!--======================================================================-->
	<!--                         Remaining Templates                          -->
	<!-- The remaining section defines the template rules. The last template  -->
	<!-- rule is a generic identity transformation used for moving complete   -->
	<!-- tree fragments from an input source to the result tree.              -->
	<!--======================================================================-->
	<!-- request -->
	<xsl:template match="portal:ibm-portal-topology">
		<request>
			<!-- @type -->
			<xsl:attribute name="type">
				<xsl:value-of select="'update'" />
			</xsl:attribute>
			<!-- @create-oids -->
			<xsl:attribute name="create-oids">
				<xsl:value-of select="$oids-creation" />
			</xsl:attribute>
			<!-- ###@export-users -->
			<!-- ###@export-mappings -->
			<!-- ###@skip-cache-refresh -->
			<!-- ###@transaction-level -->
			<!-- @xsi:noNamespaceSchemaLocation -->
			<xsl:attribute name="xsi:noNamespaceSchemaLocation">
				<xsl:value-of select="'PortalConfig_1.2.xsd'" />
			</xsl:attribute>
			<!-- portal -->
			<portal>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'locate'" />
				</xsl:attribute>
				<!-- global-settings -->
				<xsl:apply-templates select="portal:application-tree/portal:application-tree[@uniqueName='wps.any']/portal:application-element[@type='any']" />
				<!-- ###services-settings -->
				<!-- ###action-set -->
				<!-- ###virtual-resource -->
				<!-- ###protected-resource -->
				<!-- ###user -->
				<!-- ###group -->
				<!-- ###markup -->
				<!-- ###client -->
				<!-- ###event-handler -->
				<!-- skin(delete) -->
				<xsl:if test="$portaledit-xml">
					<xsl:apply-templates select="document($portaledit-xml)//delete/skin" />
				</xsl:if>
				<!-- skin -->
				<xsl:apply-templates select="portal:application-tree/portal:application-tree[@uniqueName='wps.skin']/portal:application-element[@type='skin']" />
				<!-- theme(delete) -->
				<xsl:if test="$portaledit-xml">
					<xsl:apply-templates select="document($portaledit-xml)//delete/theme" />
				</xsl:if>
				<!-- theme -->
				<xsl:apply-templates select="portal:application-tree/portal:application-tree[@uniqueName='wps.theme']/portal:application-element[@type='theme']" />
				<xsl:if test="$themesandskinsonly = 'false'">
					<!-- ###wsrp-producer -->
					<!-- ###web-app(delete) -->
					<!-- web-app -->
					<xsl:variable name="referedportlet-list">
						<xsl:for-each select="//portal:window/portal:application-element-ref">
							<xsl:value-of select="concat(';', ., ';')" />
						</xsl:for-each>
						<xsl:for-each select="//portal:layout-element/portal:parameter[base:name='allowed-portlet']/base:value">
							<xsl:value-of select="concat(';', ., ';')" />
						</xsl:for-each>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="$localportlet-xml">
							<xsl:variable name="localportlet-list">
								<xsl:for-each select="document($localportlet-xml)/uteportlets/portlet">
									<xsl:value-of select="concat(';', @portlet-name, ';')" />
								</xsl:for-each>
							</xsl:variable>
							<xsl:apply-templates select="portal:application-tree/portal:application-tree[@uniqueName='wps.portletentity']/portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';')) and contains($localportlet-list, concat(';', portal:parameter[base:name='portlet-name']/base:value, ';'))]">
								<xsl:with-param name="referedportlet-list" select="$referedportlet-list" />
								<xsl:with-param name="localportlet-list" select="$localportlet-list" />
							</xsl:apply-templates>
							<xsl:if test="$dummyportlet-web-app-uid and $dummyportlet-portlet-app-uid and $dummyportlet-portlet-name">
								<xsl:call-template name="dummyportlet" />
							</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:apply-templates select="portal:application-tree/portal:application-tree[@uniqueName='wps.portletentity']/portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';'))]">
								<xsl:with-param name="referedportlet-list" select="$referedportlet-list" />
							</xsl:apply-templates>
						</xsl:otherwise>
					</xsl:choose>
					<!-- content-node[@type='label'](delete) -->
					<xsl:if test="$portaledit-xml">
						<xsl:apply-templates select="document($portaledit-xml)//delete/label" />
					</xsl:if>
					<!-- content-node[@type='internal-url' or @type='external-url'](delete) -->
					<xsl:if test="$portaledit-xml">
						<xsl:apply-templates select="document($portaledit-xml)//delete/url-link" />
					</xsl:if>
					<!-- content-node[@type='page'](delete) -->
					<xsl:if test="$portaledit-xml">
						<xsl:apply-templates select="document($portaledit-xml)//delete/page" />
					</xsl:if>
					<!-- content-node -->
					<xsl:variable name="layout-element-ref" select="//portal:layout-element/portal:parameter[base:name='uniquename' and base:value=$content-root]/../@uniqueName" />
					<xsl:apply-templates select="//portal:navigation-element[@layout-element-ref=$layout-element-ref]" mode="content-node" />
					<xsl:variable name="application-element-ref" select="//portal:application-element/portal:parameter[base:name='uniquename' and base:value=$content-root]/../@uniqueName" />
					<xsl:apply-templates select="//portal:navigation-element[portal:navigation-content/@application-element-ref=$application-element-ref]" mode="content-node" />
					<!-- ###credential-segment -->
					<!-- url-mapping-context(delete) -->
					<xsl:if test="$portaledit-xml">
						<xsl:apply-templates select="document($portaledit-xml)//delete/url-mapping" />
					</xsl:if>
					<!-- url-mapping-context -->
<!--					<xsl:variable name="layout-element-ref" select="//portal:layout-element/portal:parameter[base:name='uniquename' and base:value=$content-root]/../@uniqueName" /> 
					<xsl:apply-templates select="//portal:navigation-element[@layout-element-ref=$layout-element-ref]" mode="url-mapping" />-->
<!--					<xsl:variable name="application-element-ref" select="//portal:application-element/portal:parameter[base:name='uniquename' and base:value=$content-root]/../@uniqueName" /> 
					<xsl:apply-templates select="//portal:navigation-element[portal:navigation-content/@application-element-ref=$application-element-ref]" mode="url-mapping" />-->
				</xsl:if>
			</portal>
			<!-- ###status -->
			<!-- ###map -->
		</request>
	</xsl:template>

	<!-- skin(delete) -->
	<xsl:template match="skin">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<skin>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'delete'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- @objectid -->
				<xsl:attribute name="objectid">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
				<!-- ###@active -->
				<!-- ###@default -->
				<!-- ###@defaultlocale -->
				<!-- ###@resouceroot -->
				<!-- ###@type -->
				<!-- ###localedata -->
			</skin>
		</xsl:if>
	</xsl:template>

	<!-- theme(delete) -->
	<xsl:template match="theme">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<theme>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'delete'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- @objectid -->
				<xsl:attribute name="objectid">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
				<!-- ###@active -->
				<!-- ###@default -->
				<!-- ###@defaultlocale -->
				<!-- ###@resourceroot -->
				<!-- ###@defaultskinref -->
				<!-- ###localedata -->
				<!-- ###allowed-skin -->
			</theme>
		</xsl:if>
	</xsl:template>

	<!-- content-node[@type='label'](delete) -->
	<xsl:template match="label">
		<xsl:call-template name="content-node-delete" />
	</xsl:template>

	<!-- content-node[@type='internal-url' or @type='external-url'](delete) -->
	<xsl:template match="url-link">
		<xsl:call-template name="content-node-delete" />
	</xsl:template>

	<!-- content-node[@type='page'](delete) -->
	<xsl:template match="page">
		<xsl:call-template name="content-node-delete" />
	</xsl:template>

	<!-- content-node[@type='label' or @type='internal-url' or @type='external-url' or @type='page'](delete) -->
	<xsl:template name="content-node-delete">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<content-node>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'delete'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- @objectid -->
				<xsl:attribute name="objectid">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
				<!-- ###@export-descendants -->
				<!-- ###@preserve-old-layout -->
				<!-- ###@type -->
				<!-- ###@active -->
				<!-- ###@content-parentref -->
				<!-- ###@derivation-parentref -->
				<!-- ###@create-type -->
				<!-- ###@shareable -->
				<!-- ###@allportletsallowed -->
				<!-- ###@themeref -->
				<!-- ###@skinref -->
				<!-- ###@ordinal -->
				<!-- ###supported-markup -->
				<!-- ###localedata -->
				<!-- ###parameter -->
				<!-- ###access-control -->
				<!-- ###allowed-portlet -->
				<!-- ###component -->
				<!-- ###wire -->
			</content-node>
		</xsl:if>
	</xsl:template>

	<!-- component[@type='row'](delete) -->
	<xsl:template match="row">
		<xsl:call-template name="component-delete" />
	</xsl:template>

	<!-- component[@type='column'](delete) -->
	<xsl:template match="column">
		<xsl:call-template name="component-delete" />
	</xsl:template>

	<!-- component[@type='portlet'](delete) -->
	<xsl:template match="portlet">
		<xsl:call-template name="component-delete" />
	</xsl:template>

	<!-- component[@type='row' or @type='column' or @type='portlet'](delete) -->
	<xsl:template name="component-delete">
		<xsl:if test="@parent-objectid and string-length(@parent-objectid)&gt;0 and @objectid and string-length(@objectid)&gt;0">
			<component>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'delete'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- @objectid -->
				<xsl:attribute name="objectid">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
				<!-- ###@active -->
				<!-- ###@type -->
				<!-- ###@ordinal -->
				<!-- ###@skinref -->
				<!-- ###@maxsize -->
				<!-- ###@width -->
				<!-- ###@deletable -->
				<!-- ###@modifiable -->
				<!-- ###@movable -->
				<!-- ###@nestable -->
				<!-- ###@orientation -->
				<!-- ###@expand-state -->
				<!-- ###@shadowref -->
				<!-- ###@shadow-parentref -->
				<!-- ###parameter -->
				<!-- ###component[@type='container'] -->
				<!-- ###component[@type='control'] -->
				<!-- ###portletinstance -->
			</component>
		</xsl:if>
	</xsl:template>

	<!-- url-mapping-context(delete) -->
	<xsl:template match="url-mapping">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<url-mapping-context>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'delete'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- @objectid -->
				<xsl:attribute name="objectid">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
				<!-- ###@label -->
				<!-- ###additional-label -->
				<!-- ###portal-url -->
				<!-- ###access-control -->
				<!-- ###url-mapping-context -->
			</url-mapping-context>
		</xsl:if>
	</xsl:template>

	<!-- allowed-skin (delete) -->
	<xsl:template match="allowed-skin">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<!-- allowed-skin -->
			<allowed-skin>
				<!-- @update -->
				<xsl:attribute name="update">
					<xsl:value-of select="'remove'" />
				</xsl:attribute>
				<!-- @skin -->
				<xsl:attribute name="skin">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
			</allowed-skin>
		</xsl:if>
	</xsl:template>

	<!-- allowed-portlet (delete) -->
	<xsl:template match="allowed-portlet">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
			<!-- allowed-portlet -->
			<allowed-portlet>
				<!-- @update -->
				<xsl:attribute name="update">
					<xsl:value-of select="'remove'" />
				</xsl:attribute>
				<!-- @portlet -->
				<xsl:attribute name="portlet">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
			</allowed-portlet>
		</xsl:if>
	</xsl:template>

	<!-- supported-markup (delete) -->
	<xsl:template match="supported-markup">
		<xsl:if test="@objectid and string-length(@objectid)&gt;0">
		<!-- supported-markup -->
			<supported-markup>
				<!-- @update -->
				<xsl:attribute name="update">
					<xsl:value-of select="'remove'" />
				</xsl:attribute>
				<!-- @markup -->
				<xsl:attribute name="markup">
					<xsl:value-of select="@objectid" />
				</xsl:attribute>
			</supported-markup>
		</xsl:if>
	</xsl:template>

	<!-- skin theme web-app -->
	<xsl:template match="portal:application-element">
		<xsl:param name="referedportlet-list" />
		<xsl:param name="localportlet-list" />
		<xsl:if test="@type='any'">
			<!-- global-settings -->
			<xsl:call-template name="global-settings" />
		</xsl:if>
		<xsl:if test="@type='skin'">
			<!-- skin -->
			<xsl:call-template name="skin" />
		</xsl:if>
		<xsl:if test="@type='theme'">
			<!-- theme -->
			<xsl:call-template name="theme" />
		</xsl:if>
		<xsl:if test="@type='portletentity'">
			<!-- web-app -->
			<xsl:call-template name="portletentity">
				<xsl:with-param name="referedportlet-list" select="$referedportlet-list" />
				<xsl:with-param name="localportlet-list" select="$localportlet-list" />
			</xsl:call-template>
		</xsl:if>
	</xsl:template>

	<!-- global-settings -->
	<xsl:template name="global-settings">
		<!-- global-settings -->
		<global-settings>
			<!-- @action -->
			<xsl:call-template name="action" />
			<!-- parameter[@name='locale.default.country' or @name='locale.default.language' or @name='locale.default.variant'] -->
			<xsl:variable name="default-language" select="portal:parameter[base:name='default-language']/base:value" />
			<xsl:choose>
				<xsl:when test="contains($default-language, '_')">
					<xsl:variable name="default-country" select="substring-after($default-language, '_')" />
					<xsl:choose>
						<xsl:when test="contains($default-country, '_')">
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.language'" />
								<xsl:with-param name="type" select="'string'" />
								<xsl:with-param name="value" select="substring-before($default-language, '_')" />
							</xsl:call-template>
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.country'" />
								<xsl:with-param name="type" select="'string'" />
								<xsl:with-param name="value" select="substring-before($default-country, '_')" />
							</xsl:call-template>
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.variant'" />
								<xsl:with-param name="type" select="'string'" />
								<xsl:with-param name="value" select="substring-after($default-country, '_')" />
							</xsl:call-template>
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.language'" />
								<xsl:with-param name="type" select="'string'" />
								<xsl:with-param name="value" select="substring-before($default-language, '_')" />
							</xsl:call-template>
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.country'" />
								<xsl:with-param name="type" select="'string'" />
								<xsl:with-param name="value" select="substring-after($default-language, '_')" />
							</xsl:call-template>
							<xsl:call-template name="parameter">
								<xsl:with-param name="name" select="'locale.default.variant'" />
								<xsl:with-param name="type" select="'string'" />
							</xsl:call-template>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="parameter">
						<xsl:with-param name="name" select="'locale.default.language'" />
						<xsl:with-param name="type" select="'string'" />
						<xsl:with-param name="value" select="$default-language" />
					</xsl:call-template>
					<xsl:call-template name="parameter">
						<xsl:with-param name="name" select="'locale.default.country'" />
						<xsl:with-param name="type" select="'string'" />
					</xsl:call-template>
					<xsl:call-template name="parameter">
						<xsl:with-param name="name" select="'locale.default.variant'" />
						<xsl:with-param name="type" select="'string'" />
					</xsl:call-template>
				</xsl:otherwise>
			</xsl:choose>
		</global-settings>
	</xsl:template>

	<!-- skin -->
	<xsl:template name="skin">
		<!-- skin -->
		<skin>
			<!-- @action @uniquename @objectid -->
			<xsl:call-template name="defaultResourceAttr" />
			<!-- @active -->
			<xsl:call-template name="active" />
			<!-- @default -->
			<xsl:call-template name="default" />
			<!-- ###@defaultlocale -->
			<!-- @resouceroot -->
			<xsl:call-template name="resourceroot" />
			<!-- @type -->
			<xsl:attribute name="type">
				<xsl:value-of select="'default'" />
			</xsl:attribute>
			<!-- localedata -->
			<xsl:call-template name="localedata" />
		</skin>
	</xsl:template>

	<!-- theme -->
	<xsl:template name="theme">
		<theme>
			<!-- @action @uniquename @objectid -->
			<xsl:call-template name="defaultResourceAttr" />
			<!-- @active -->
			<xsl:call-template name="active" />
			<!-- @default -->
			<xsl:call-template name="default" />
			<!-- ###@defaultlocale -->
			<!-- @resourceroot -->
			<xsl:call-template name="resourceroot" />
			<!-- @defaultskinref -->
			<xsl:if test="portal:parameter[base:name='defaultskinref']">
				<xsl:attribute name="defaultskinref">
					<xsl:variable name="defaultskinref" select="portal:parameter[base:name='defaultskinref']/base:value" />
					<xsl:call-template name="application-element-ref">
						<xsl:with-param name="ref" select="$defaultskinref" />
					</xsl:call-template>
				</xsl:attribute>
			</xsl:if>
			<!-- localedata -->
			<xsl:call-template name="localedata" />
			<!-- allowed-skin (delete) -->
			<xsl:if test="$portaledit-xml">
				<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
				<xsl:variable name="uniquename" select="portal:parameter[base:name='uniquename']/base:value"/>
				<!-- allowed-skin (delete) -->
				<xsl:if test="$objectid and string-length($objectid)&gt;0">
					<xsl:apply-templates select="document($portaledit-xml)//delete/allowed-skin[@parent-objectid=$objectid]" />
				</xsl:if>
				<xsl:if test="not($objectid or string-length($objectid)&gt;0)">
					<xsl:apply-templates select="document($portaledit-xml)//delete/allowed-skin[@parent-uniquename=$uniquename]" />
				</xsl:if>
			</xsl:if>
			<!-- allowed-skin -->
			<xsl:call-template name="allowed-skin" />
		</theme>
	</xsl:template>

	<!-- web-app -->
	<xsl:template name="portletentity">
		<xsl:param name="referedportlet-list" />
		<xsl:param name="localportlet-list" />
		<xsl:variable name="web-app-uid" select="portal:parameter[base:name='web-app-uid']/base:value" />
		<xsl:variable name="preceding-web-app-uid">
			<xsl:choose>
				<xsl:when test="$localportlet-list">
					<xsl:for-each select="preceding-sibling::portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';')) and contains($localportlet-list, concat(';', portal:parameter[base:name='portlet-name']/base:value, ';'))]">
						<xsl:value-of select="concat(';', portal:parameter[base:name='web-app-uid']/base:value, ';')" />
					</xsl:for-each>
				</xsl:when>
				<xsl:otherwise>
					<xsl:for-each select="preceding-sibling::portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';'))]">
						<xsl:value-of select="concat(';', portal:parameter[base:name='web-app-uid']/base:value, ';')" />
					</xsl:for-each>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="not(contains($preceding-web-app-uid, concat(';', $web-app-uid, ';')))">
			<!-- web-app -->
			<web-app>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'locate'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- ###@objectid -->
				<!-- ###@active -->
				<!-- @uid -->
				<xsl:attribute name="uid">
					<xsl:value-of select="$web-app-uid" />
				</xsl:attribute>
				<!-- ###@removable -->
				<!-- ###@debug -->
				<!-- ###url -->
				<!-- ###context-root -->
				<!-- ###access-control -->
				<!-- ###servlet -->
				<!-- portal-app -->
				<xsl:choose>
					<xsl:when test="$localportlet-list">
						<xsl:apply-templates select="../portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';')) and contains($localportlet-list, concat(';', portal:parameter[base:name='portlet-name']/base:value, ';'))]" mode="web-app-uid">
							<xsl:with-param name="referedportlet-list" select="$referedportlet-list" />
							<xsl:with-param name="localportlet-list" select="$localportlet-list" />
							<xsl:with-param name="web-app-uid" select="$web-app-uid" />
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="../portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';'))]" mode="web-app-uid">
							<xsl:with-param name="referedportlet-list" select="$referedportlet-list" />
							<xsl:with-param name="localportlet-list" select="$localportlet-list" />
							<xsl:with-param name="web-app-uid" select="$web-app-uid" />
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</web-app>
		</xsl:if>
	</xsl:template>

	<!-- portlet-app -->
	<xsl:template match="portal:application-element" mode="web-app-uid">
		<xsl:param name="localportlet-list" />
		<xsl:param name="referedportlet-list" />
		<xsl:param name="web-app-uid" />
		<xsl:if test="$web-app-uid=portal:parameter[base:name='web-app-uid']/base:value">
			<xsl:variable name="portlet-app-uid" select="portal:parameter[base:name='portlet-app-uid']/base:value" />
			<xsl:variable name="preceding-portlet-app-uid">
				<xsl:choose>
					<xsl:when test="$localportlet-list">
						<xsl:for-each select="preceding-sibling::portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';')) and contains($localportlet-list, concat(';', portal:parameter[base:name='portlet-name']/base:value, ';'))]">
							<xsl:value-of select="concat(';', portal:parameter[base:name='portlet-app-uid']/base:value, ';')" />
						</xsl:for-each>
					</xsl:when>
					<xsl:otherwise>
						<xsl:for-each select="preceding-sibling::portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';'))]">
							<xsl:value-of select="concat(';', portal:parameter[base:name='portlet-app-uid']/base:value, ';')" />
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="not(contains($preceding-portlet-app-uid, concat(';', $portlet-app-uid, ';')))">
				<!-- portlet-app -->
				<portlet-app>
					<!-- @action -->
					<xsl:attribute name="action">
						<xsl:value-of select="'locate'" />
					</xsl:attribute>
					<!-- ###@uniquename -->
					<!-- ###@objectid -->
					<!-- ###@active -->
					<!-- @uid -->
					<xsl:attribute name="uid">
						<xsl:value-of select="$portlet-app-uid" />
					</xsl:attribute>
					<!-- ###@defaultlocale -->
					<!-- ###@groupid -->
					<!-- ###localedata -->
					<!-- ###parameter -->
					<!-- ###access-control -->
					<!-- portlet -->
					<xsl:choose>
						<xsl:when test="$localportlet-list">
							<xsl:apply-templates select="../portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';')) and contains($localportlet-list, concat(';', portal:parameter[base:name='portlet-name']/base:value, ';'))]" mode="portlet-app-uid">
								<xsl:with-param name="portlet-app-uid" select="$portlet-app-uid" />
							</xsl:apply-templates>
						</xsl:when>
						<xsl:otherwise>
							<xsl:apply-templates select="../portal:application-element[@type='portletentity' and contains($referedportlet-list, concat(';', @uniqueName, ';'))]" mode="portlet-app-uid">
								<xsl:with-param name="portlet-app-uid" select="$portlet-app-uid" />
							</xsl:apply-templates>
						</xsl:otherwise>
					</xsl:choose>
				</portlet-app>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- portlet -->
	<xsl:template match="portal:application-element" mode="portlet-app-uid">
		<xsl:param name="portlet-app-uid" />
		<xsl:if test="$portlet-app-uid=portal:parameter[base:name='portlet-app-uid']/base:value">
			<!-- portlet -->
			<portlet>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'locate'" />
				</xsl:attribute>
				<!-- @uniquename -->
				<xsl:call-template name="uniquename" />
				<!-- @objectid -->
				<xsl:call-template name="objectid" />
				<!-- @name -->
				<xsl:attribute name="name">
					<xsl:value-of select="portal:parameter[base:name='portlet-name']/base:value" />
				</xsl:attribute>
				<!-- ###@active -->
				<!-- ###@provided -->
				<!-- ###@handle -->
				<!-- ###@defaultlocale -->
				<!-- ###@servletref -->
				<!-- localedata -->
				<xsl:call-template name="localedata" />
				<!-- ###parameter -->
				<!-- ###preferences -->
				<!-- ###access-control -->
			</portlet>
		</xsl:if>
	</xsl:template>

	<xsl:template name="dummyportlet">
		<!-- web-app -->
		<web-app>
			<!-- @action -->
			<xsl:attribute name="action">
				<xsl:value-of select="'locate'" />
			</xsl:attribute>
			<!-- ###@uniquename -->
			<!-- ###@objectid -->
			<!-- ###@active -->
			<!-- @uid -->
			<xsl:attribute name="uid">
				<xsl:value-of select="$dummyportlet-web-app-uid" />
			</xsl:attribute>
			<!-- ###@removable -->
			<!-- ###@debug -->
			<!-- ###url -->
			<!-- ###context-root -->
			<!-- ###access-control -->
			<!-- ###servlet -->
			<!-- portlet-app -->
			<portlet-app>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'locate'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- ###@objectid -->
				<!-- ###@active -->
				<!-- @uid -->
				<xsl:attribute name="uid">
					<xsl:value-of select="$dummyportlet-portlet-app-uid" />
				</xsl:attribute>
				<!-- ###@defaultlocale -->
				<!-- ###@groupid -->
				<!-- ###localedata -->
				<!-- ###parameter -->
				<!-- ###access-control -->
				<!-- portlet -->
				<portlet>
					<!-- @action -->
					<xsl:attribute name="action">
						<xsl:value-of select="'locate'" />
					</xsl:attribute>
					<!-- ###@uniquename -->
					<!-- @objectid -->
					<xsl:attribute name="objectid">
						<xsl:value-of select="concat('OID_', translate($dummyportlet-portlet-name, ' ', '_'))" />
					</xsl:attribute>
					<!-- @name -->
					<xsl:attribute name="name">
						<xsl:value-of select="$dummyportlet-portlet-name" />
					</xsl:attribute>
					<!-- ###@active -->
					<!-- ###@provided -->
					<!-- ###@handle -->
					<!-- ###@defaultlocale -->
					<!-- ###@servletref -->
					<!-- ###localedata -->
					<!-- ###parameter -->
					<!-- ###preferences -->
					<!-- ###access-control -->
				</portlet>
			</portlet-app>
		</web-app>
	</xsl:template>

	<!-- content-node -->
	<xsl:template match="portal:navigation-element" mode="content-node">
		<xsl:param name="content-parentref" />
		<xsl:choose>
			<!-- content-node[@type='label' or @type='internal-url' or @type='external-url'] -->
			<xsl:when test="portal:navigation-content/@application-element-ref">
				<xsl:variable name="application-element-ref" select="portal:navigation-content/@application-element-ref" />
				<xsl:apply-templates select="//portal:application-element[@uniqueName=$application-element-ref]" mode="content-node">
					<xsl:with-param name="content-parentref" select="$content-parentref" />
				</xsl:apply-templates>
				<xsl:variable name="application-element-ref-objectid" select="//portal:application-element[@uniqueName=$application-element-ref]/portal:parameter[base:name='objectid']/base:value" />
				<!-- content-node (children) -->
				<xsl:choose>
					<xsl:when test="$application-element-ref-objectid">
						<xsl:apply-templates select="portal:navigation-element" mode="content-node">
							<xsl:with-param name="content-parentref" select="$application-element-ref-objectid" />
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="portal:navigation-element" mode="content-node">
							<xsl:with-param name="content-parentref" select="concat('OID_', translate($application-element-ref, ' ', '_'))" />
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<!-- content-node[@type='page'] -->
			<xsl:when test="@layout-element-ref">
				<xsl:variable name="layout-element-ref" select="@layout-element-ref" />
				<xsl:apply-templates select="//portal:layout-element[@uniqueName=$layout-element-ref]" mode="content-node">
					<xsl:with-param name="content-parentref" select="$content-parentref" />
				</xsl:apply-templates>
				<xsl:variable name="layout-element-ref-objectid" select="//portal:layout-element[@uniqueName=$layout-element-ref]/portal:parameter[base:name='objectid']/base:value" />
				<!-- content-node (children) -->
				<xsl:choose>
					<xsl:when test="$layout-element-ref-objectid">
						<xsl:apply-templates select="portal:navigation-element" mode="content-node">
							<xsl:with-param name="content-parentref" select="$layout-element-ref-objectid" />
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="portal:navigation-element" mode="content-node">
							<xsl:with-param name="content-parentref" select="concat('OID_', translate($layout-element-ref, ' ', '_'))" />
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise></xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- content-node[@type='label' or @type='internal-url' or @type='external-url'] -->
	<xsl:template match="portal:application-element" mode="content-node">
		<xsl:param name="content-parentref" />
		<xsl:if test="@type='label'">
			<!-- content-node[@type='label'] -->
			<content-node>
				<!-- @action @uniquename @objectid -->
				<xsl:call-template name="defaultResourceAttr" />
				<!-- ###@export-descendants -->
				<!-- @preserve-old-layout -->
				<xsl:attribute name="preserve-old-layout">
					<xsl:value-of select="'true'" />
				</xsl:attribute>
				<!-- @type -->
				<xsl:attribute name="type">
					<xsl:value-of select="'label'" />
				</xsl:attribute>
				<!-- @active -->
				<xsl:call-template name="active" />
				<!-- @content-parentref -->
				<xsl:if test="$content-parentref">
					<xsl:attribute name="content-parentref">
						<xsl:value-of select="$content-parentref" />
					</xsl:attribute>
				</xsl:if>
				<!-- ###@derivation-parentref -->
				<!-- ###@create-type -->
				<!-- ###@shareable -->
				<!-- ###@allportletsallowed -->
				<!-- @themeref -->
				<xsl:call-template name="themeref" />
				<!-- @skinref -->
				<xsl:call-template name="skinref" />
				<!-- @ordinal -->
				<xsl:call-template name="ordinal" />
				<!-- supported-markup (delete) -->
				<xsl:if test="$portaledit-xml">
					<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
					<xsl:variable name="uniquename" select="portal:parameter[base:name='uniquename']/base:value"/>
					<!-- allowed-skin (delete) -->
					<xsl:if test="$objectid and string-length($objectid)&gt;0">
						<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-objectid=$objectid]" />			
					</xsl:if>
					<xsl:if test="not($objectid or string-length($objectid)&gt;0)">
						<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-uniquename=$uniquename]" />
					</xsl:if>
				</xsl:if>
				<!-- supported-markup -->
				<xsl:for-each select="portal:parameter[base:name='supported-markup']">
					<xsl:call-template name="supported-markup" />
				</xsl:for-each>
				<!-- localedata -->
				<xsl:call-template name="localedata" />
				<!-- ###parameter -->
				<!-- ###access-control -->
				<!-- ###allowed-portlet -->
				<!-- ###component -->
				<!-- ###wire -->
			</content-node>
		</xsl:if>
		<xsl:if test="@type='urlLink'">
			<!-- content-node[@type='urlLink'] -->
			<content-node>
				<!-- @action @uniquename @objectid -->
				<xsl:call-template name="defaultResourceAttr" />
				<!-- ###@export-descendants -->
				<!-- @preserve-old-layout -->
				<xsl:attribute name="preserve-old-layout">
					<xsl:value-of select="'true'" />
				</xsl:attribute>
				<!-- @type -->
				<xsl:attribute name="type">
					<xsl:choose>
						<xsl:when test="portal:parameter[base:name='type']/base:value='internal'">
							<xsl:value-of select="'internal-url'" />
						</xsl:when>
						<xsl:when test="portal:parameter[base:name='type']/base:value='external'">
							<xsl:value-of select="'external-url'" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'external-url'" />
						</xsl:otherwise>
					</xsl:choose>
				</xsl:attribute>
				<!-- @active -->
				<xsl:call-template name="active" />
				<!-- @content-parentref -->
				<xsl:if test="$content-parentref">
					<xsl:attribute name="content-parentref">
						<xsl:value-of select="$content-parentref" />
					</xsl:attribute>
				</xsl:if>
				<!-- ###@derivation-parentref -->
				<!-- ###@create-type -->
				<!-- ###@shareable -->
				<!-- ###@allportletsallowed -->
				<!-- ###@themeref -->
				<!-- ###@skinref -->
				<!-- @ordinal -->
				<xsl:call-template name="ordinal" />
				<!-- supported-markup (delete) -->
				<xsl:if test="$portaledit-xml">
					<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
					<xsl:variable name="uniquename" select="portal:parameter[base:name='uniquename']/base:value"/>
					<!-- allowed-skin (delete) -->
					<xsl:if test="$objectid and string-length($objectid)&gt;0">
						<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-objectid=$objectid]" />			
					</xsl:if>
					<xsl:if test="not($objectid or string-length($objectid)&gt;0)">
						<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-uniquename=$uniquename]" />
					</xsl:if>
				</xsl:if>
				
				<!-- supported-markup -->
				<xsl:for-each select="portal:parameter[base:name='supported-markup']">
					<xsl:call-template name="supported-markup" />
				</xsl:for-each>
				<!-- localedata -->
				<xsl:call-template name="localedata" />
				<!-- ###parameter -->
				<!-- ###access-control -->
				<!-- ###allowed-portlet -->
				<!-- ###component -->
				<!-- ###wire -->
			</content-node>
		</xsl:if>
	</xsl:template>

	<!-- content-node[@type='page'] -->
	<xsl:template match="portal:layout-element" mode="content-node">
		<xsl:param name="content-parentref" />
		<!-- content-node[@type='page'] -->
		<content-node>
			<!-- @action @uniquename @objectid -->
			<xsl:call-template name="defaultResourceAttr" />
			<!-- ###@export-descendants -->
			<!-- @preserve-old-layout -->
			<xsl:attribute name="preserve-old-layout">
				<xsl:value-of select="'true'" />
			</xsl:attribute>
			<!-- @type -->
			<xsl:attribute name="type">
				<xsl:value-of select="'page'" />
			</xsl:attribute>
			<!-- @active -->
			<xsl:call-template name="active" />
			<!-- @content-parentref -->
			<xsl:if test="$content-parentref">
				<xsl:attribute name="content-parentref">
					<xsl:value-of select="$content-parentref" />
				</xsl:attribute>
			</xsl:if>
			<!-- @derivation-parentref -->
			<xsl:call-template name="derivation-parentref" />
			<!-- ###@create-type -->
			<!-- @shareable -->
			<xsl:call-template name="shareable" />
			<!-- @allportletsallowed -->
			<xsl:call-template name="allportletsallowed" />
			<!-- @themeref -->
			<xsl:call-template name="themeref" />
			<!-- @skinref -->
			<xsl:call-template name="skinref" />
			<!-- @ordinal -->
			<xsl:call-template name="ordinal" />
			
			<!-- supported-markup (delete) -->
			<xsl:if test="$portaledit-xml">
				<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
				<xsl:variable name="uniquename" select="portal:parameter[base:name='uniquename']/base:value"/>
				<!-- allowed-skin (delete) -->
				<xsl:if test="$objectid and string-length($objectid)&gt;0">
					<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-objectid=$objectid]" />			
				</xsl:if>
				<xsl:if test="not($objectid or string-length($objectid)&gt;0)">
					<xsl:apply-templates select="document($portaledit-xml)//delete/supported-markup[@parent-uniquename=$uniquename]" />
				</xsl:if>
			</xsl:if>
			
			<!-- supported-markup -->
			<xsl:for-each select="portal:parameter[base:name='supported-markup']">
				<xsl:call-template name="supported-markup" />
			</xsl:for-each>
			<!-- localedata -->
			<xsl:call-template name="localedata" />
			<!-- parameter -->
			<xsl:for-each select="portal:parameter[base:name='bookmarkable']">
				<xsl:call-template name="bookmarkable" />
			</xsl:for-each>
			<!-- ###access-control -->
			<!-- allowed-skin (delete) -->
			<xsl:if test="$portaledit-xml">
				<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
				<xsl:variable name="uniquename" select="portal:parameter[base:name='uniquename']/base:value"/>
				<!-- allowed-portlet (delete) -->				
				<xsl:if test="$objectid and string-length($objectid)&gt;0">
					<xsl:apply-templates select="document($portaledit-xml)//delete/allowed-portlet[@parent-objectid=$objectid]" />
				</xsl:if>
				<xsl:if test="not($objectid or string-length($objectid)&gt;0)">
					<xsl:apply-templates select="document($portaledit-xml)//delete/allowed-portlet[@parent-uniquename=$uniquename]" />
				</xsl:if>
			</xsl:if>
			<!-- allowed-portlet -->
			<xsl:for-each select="portal:parameter[base:name='allowed-portlet']">
				<xsl:call-template name="allowed-portlet" />
			</xsl:for-each>
			<!-- component[@type='row' or @type='column' or @type='portlet'](delete) -->
			<xsl:if test="$portaledit-xml">
				<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
				<!-- component[@type='row'](delete) -->
				<xsl:apply-templates select="document($portaledit-xml)//delete/row[@parent-objectid=$objectid]" />
				<!-- component[@type='column'](delete) -->
				<xsl:apply-templates select="document($portaledit-xml)//delete/column[@parent-objectid=$objectid]" />
				<!-- component[@type='portlet'](delete) -->
				<xsl:apply-templates select="document($portaledit-xml)//delete/portlet[@parent-objectid=$objectid]" />
			</xsl:if>
			<!-- component[@type='container'] -->
			<xsl:apply-templates select="portal:container" />
			<!-- component[@type='control'] -->
			<xsl:apply-templates select="portal:window" />
			<!-- ###wire -->
		</content-node>
	</xsl:template>

	<!-- component[@type='container' or @type='control'] -->
	<xsl:template match="portal:container">
		<xsl:variable name="derivation-container" select="portal:parameter[base:name='derivation-container']/base:value" />
		<xsl:choose>
			<xsl:when test="$derivation-container='true'">
				<!-- component[@type='container'] -->
				<xsl:apply-templates select="portal:container" />
				<!-- component[@type='control'] -->
				<xsl:apply-templates select="portal:window" />
			</xsl:when>
			<xsl:otherwise>
				<!-- component[@type='container'] -->
				<component>
					<!-- @action @uniquename @objectid -->
					<xsl:choose>
						<xsl:when test="$nolayoutuniquename='true'">
							<!-- @action -->
							<xsl:call-template name="action" />
							<!-- @objectid -->
							<xsl:call-template name="objectid" />
						</xsl:when>
						<xsl:otherwise>
							<xsl:call-template name="defaultResourceAttr" />
						</xsl:otherwise>
					</xsl:choose>
					<!-- @active -->
					<xsl:call-template name="active" />
					<!-- @type -->
					<xsl:attribute name="type">
						<xsl:value-of select="'container'" />
					</xsl:attribute>
					<!-- @ordinal -->
					<xsl:call-template name="ordinal" />
					<!-- @skinref -->
					<xsl:call-template name="skinref" />
					<!-- ###@maxsize -->
					<!-- @width -->
					<xsl:call-template name="width" />
					<!-- @deletable -->
					<xsl:call-template name="deletable" />
					<!-- @modifiable -->
					<xsl:call-template name="modifiable" />
					<!-- @movable -->
					<xsl:call-template name="movable" />
					<!-- @nestable -->
					<xsl:call-template name="nestable" />
					<!-- @orientation -->
					<xsl:variable name="shadowref" select="portal:parameter[base:name='shadowref']/base:value" />
					<xsl:if test="not($shadowref)">
						<xsl:attribute name="orientation">
							<xsl:choose>
								<xsl:when test="@type='row'">
									<xsl:value-of select="'H'" />
								</xsl:when>
								<xsl:when test="@type='column'">
									<xsl:value-of select="'V'" />
								</xsl:when>
							</xsl:choose>
						</xsl:attribute>
					</xsl:if>
					<!-- ###@expand-state -->
					<!-- @shadowref -->
					<xsl:call-template name="shadowref" />
					<!-- @shadow-parentref -->
					<xsl:call-template name="shadow-parentref" />
					<!-- ###parameter -->
					<!-- component[@type='container'] -->
					<xsl:apply-templates select="portal:container" />
					<!-- component[@type='control'] -->
					<xsl:apply-templates select="portal:window" />
					<!-- ###portletinstance -->
				</component>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- component[@type='control'] -->
	<xsl:template match="portal:window">
		<!-- component -->
		<component>
			<!-- @action @uniquename @objectid -->
			<xsl:choose>
				<xsl:when test="$nolayoutuniquename='true'">
					<!-- @action -->
					<xsl:call-template name="action" />
					<!-- @objectid -->
					<xsl:call-template name="objectid" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="defaultResourceAttr" />
				</xsl:otherwise>
			</xsl:choose>
			<!-- @active -->
			<xsl:call-template name="active" />
			<!-- @type -->
			<xsl:attribute name="type">
				<xsl:value-of select="'control'" />
			</xsl:attribute>
			<!-- @ordinal -->
			<xsl:call-template name="ordinal" />
			<!-- @skinref -->
			<xsl:call-template name="skinref" />
			<!-- ###@maxsize -->
			<!-- ###@width -->
			<!-- @deletable -->
			<xsl:call-template name="deletable" />
			<!-- @modifiable -->
			<xsl:call-template name="modifiable" />
			<!-- @movable -->
			<xsl:call-template name="movable" />
			<!-- ###@nestable -->
			<!-- ###@orientation -->
			<!-- ###@expand-state -->
			<!-- @shadowref -->
			<xsl:call-template name="shadowref" />
			<!-- @shadow-parentref -->
			<xsl:call-template name="shadow-parentref" />
			<!-- ###parameter -->
			<!-- ###component -->
			<!-- portletinstance -->
			<xsl:call-template name="portletinstance" />
		</component>
	</xsl:template>

	<!-- url-mapping-context -->
	<xsl:template match="portal:navigation-element" mode="url-mapping">
		<xsl:variable name="application-element-ref" select="portal:navigation-content/@application-element-ref" />
		<xsl:if test="$application-element-ref">
			<xsl:apply-templates select="//portal:application-element[@uniqueName=$application-element-ref]" mode="url-mapping" />
			<!-- content-node (children) -->
			<xsl:apply-templates select="portal:navigation-element" mode="url-mapping" />
		</xsl:if>
	</xsl:template>

	<!-- url-mapping-context -->
	<xsl:template match="portal:application-element" mode="url-mapping">
		<xsl:if test="@type='urlLink'">
			<xsl:if test="portal:parameter[base:name='type']/base:value='internal'">
				<xsl:variable name="url" select="portal:parameter[base:name='url']/base:value" />
				<xsl:variable name="layout-element-ref" select="//portal:navigation-element[@uniqueName=$url]/@layout-element-ref" />
				<xsl:if test="$layout-element-ref">
					<!-- url-mapping-context -->
					<url-mapping-context>
						<!-- @action -->
						<xsl:attribute name="action">
							<xsl:value-of select="'update'" />
						</xsl:attribute>
						<!-- ###@uniquename -->
						<!-- ###@objectid -->
						<!-- @label -->
						<xsl:call-template name="label" />
						<!-- ###additional-label -->
						<!-- portal-url -->
						<portal-url>
							<!-- @resourceref -->
							<xsl:attribute name="resourceref">
								<xsl:call-template name="layout-element-ref">
									<xsl:with-param name="ref" select="$layout-element-ref" />
								</xsl:call-template>
							</xsl:attribute>
							<!-- ###@locale -->
						</portal-url>
						<!-- ###access-control -->
						<!-- ###url-mapping-context -->
					</url-mapping-context>
				</xsl:if>
			</xsl:if>
		</xsl:if>
	</xsl:template>

	<!-- parameter -->
	<xsl:template name="parameter">
		<xsl:param name="name" />
		<xsl:param name="type" />
		<xsl:param name="value" />
		<parameter>
			<!-- @name -->
			<xsl:attribute name="name">
				<xsl:value-of select="$name" />
			</xsl:attribute>
			<!-- @type -->
			<xsl:attribute name="type">
				<xsl:value-of select="$type" />
			</xsl:attribute>
			<!-- @update -->
			<xsl:attribute name="update">
				<xsl:value-of select="'set'" />
			</xsl:attribute>
			<xsl:value-of select="$value" />
		</parameter>
	</xsl:template>
	
	<!-- @action @objectid @uniquename -->
	<xsl:template name="defaultResourceAttr">
		<!-- @action -->
		<xsl:call-template name="action" />
		<!-- @uniquename -->
		<xsl:call-template name="uniquename" />
		<!-- @objectid -->
		<xsl:call-template name="objectid" />
	</xsl:template>
	
	<!-- @action -->
	<xsl:template name="action">
		<xsl:attribute name="action">
			<xsl:value-of select="'update'" />
		</xsl:attribute>
	</xsl:template>

	<!-- @uniquename -->
	<xsl:template name="uniquename">
		<xsl:if test="portal:parameter[base:name='uniquename']">
			<xsl:attribute name="uniquename">
				<xsl:value-of select="portal:parameter[base:name='uniquename']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @objectid -->
	<xsl:template name="objectid">
		<xsl:attribute name="objectid">
			<xsl:variable name="objectid" select="portal:parameter[base:name='objectid']/base:value" />
			<xsl:choose>
				<xsl:when test="$objectid and string-length($objectid)&gt;0">
					<xsl:value-of select="$objectid" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:if test="@uniqueName and string-length(@uniqueName)&gt;0">
						<xsl:value-of select="concat('OID_', translate(@uniqueName, ' ', '_'))" />
					</xsl:if>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:attribute>
	</xsl:template>
	
	<!-- @active -->
	<xsl:template name="active">
		<xsl:attribute name="active">
			<xsl:if test="portal:parameter[base:name='active']">
				<xsl:value-of select="portal:parameter[base:name='active']/base:value" />
			</xsl:if>
			<xsl:if test="not(portal:parameter[base:name='active'])">
				<xsl:value-of select="'true'" />
			</xsl:if>
		</xsl:attribute>
	</xsl:template>

	<!-- portletinstance -->
	<xsl:template name="portletinstance">
		<xsl:variable name="application-element-ref" select="portal:application-element-ref" />
		<xsl:if test="$application-element-ref and string-length($application-element-ref)&gt;0 and not($application-element-ref='undefined')">
			<portletinstance>
				<!-- @action -->
				<xsl:attribute name="action">
					<xsl:value-of select="'update'" />
				</xsl:attribute>
				<!-- ###@uniquename -->
				<!-- ###@objectid -->
				<!-- @portletref -->
				<xsl:call-template name="portletref" />
				<!-- ###@shareref -->
				<!-- ###@handle -->
				<!-- ###parameter -->
				<!-- ###preferences -->
			</portletinstance>
		</xsl:if>
	</xsl:template>
	
	<!-- @portletref -->
	<xsl:template name="portletref">
		<xsl:if test="portal:application-element-ref">
			<xsl:attribute name="portletref">
				<xsl:variable name="application-element-ref" select="portal:application-element-ref" />
				<xsl:choose>
					<xsl:when test="$localportlet-xml">
						<xsl:variable name="localportlet-list">
							<xsl:for-each select="document($localportlet-xml)/uteportlets/portlet">
								<xsl:value-of select="concat(';', @portlet-name, ';')" />
							</xsl:for-each>
						</xsl:variable>
						<xsl:variable name="portlet-name" select="//portal:application-element[@uniqueName=$application-element-ref]/portal:parameter[base:name='portlet-name']/base:value" />
						<xsl:choose>
							<xsl:when test="contains($localportlet-list, concat(';', $portlet-name, ';'))">
								<xsl:call-template name="application-element-ref">
									<xsl:with-param name="ref" select="$application-element-ref" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test="$dummyportlet-portlet-name">
									<xsl:value-of select="concat('OID_', translate($dummyportlet-portlet-name, ' ', '_'))" />
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="application-element-ref">
							<xsl:with-param name="ref" select="$application-element-ref" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @themeref -->
	<xsl:template name="themeref">
		<xsl:if test="portal:parameter[base:name='themeref']">
			<xsl:attribute name="themeref">
				<xsl:variable name="themeref" select="portal:parameter[base:name='themeref']/base:value" />
				<xsl:call-template name="application-element-ref">
					<xsl:with-param name="ref" select="$themeref" />
				</xsl:call-template>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @skinref -->
	<xsl:template name="skinref">
		<xsl:if test="portal:parameter[base:name='skinref']">
			<xsl:attribute name="skinref">
				<xsl:variable name="skinref" select="portal:parameter[base:name='skinref']/base:value" />
				<xsl:call-template name="application-element-ref">
					<xsl:with-param name="ref" select="$skinref" />
				</xsl:call-template>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- localedata -->
	<xsl:template name="localedata">
		<xsl:for-each select="portal:title/base:nls-string">
			<xsl:if test="@lang">
				<!-- localedata -->
				<localedata>
					<!-- ###@charset -->
					<!-- ###@prefix -->
					<!-- @locale -->
					<xsl:attribute name="locale">
						<xsl:value-of select="translate(@lang, '-', '_')" />
					</xsl:attribute>
					<!-- title -->
					<title>
						<xsl:value-of select="." />
					</title>
					<!-- description -->
					<xsl:variable name="lang" select="@lang" />
					<xsl:if test="../../portal:description/base:nls-string[@lang=$lang]">
						<description>
							<xsl:value-of select="../../portal:description/base:nls-string[@lang=$lang]" />
						</description>
					</xsl:if>
					<!-- ###keywords -->
					<!-- ###url -->
				</localedata>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- allowed-skin -->
	<xsl:template name="allowed-skin">
		<xsl:if test="portal:parameter/base:name='allowed-skin'">
			<xsl:for-each select="portal:parameter[base:name='allowed-skin']/base:value">
				<xsl:variable name="allowed-skin" select="." />
				<xsl:variable name="allowed-skin-ref">
					<xsl:call-template name="application-element-ref">
						<xsl:with-param name="ref" select="$allowed-skin" />
					</xsl:call-template>
				</xsl:variable>
				<xsl:if test="not($allowed-skin-ref='undefined')">
					<!-- allowed-skin -->
					<allowed-skin>
						<!-- @update -->
						<xsl:attribute name="update">
							<xsl:value-of select="'set'" />
						</xsl:attribute>
						<!-- @skin -->
						<xsl:attribute name="skin">
							<xsl:value-of select="$allowed-skin-ref" />
						</xsl:attribute>
					</allowed-skin>
				</xsl:if>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>

	<!-- supported-markup -->
	<xsl:template name="supported-markup">
		<xsl:for-each select="base:value">
			<xsl:variable name="markup" select="." />
			<xsl:choose>
				<xsl:when test="../../@type='urlLink'">
					<!-- supported-markup -->
					<supported-markup>
						<!-- @markup -->
						<xsl:attribute name="markup">
							<xsl:value-of select="$markup" />
						</xsl:attribute>
						<!-- @update -->
						<xsl:attribute name="update">
							<xsl:value-of select="'set'" />
						</xsl:attribute>
						<xsl:variable name="position" select="position()" />
						<xsl:variable name="url" select="../../portal:parameter[base:name='url']/base:value[$position]" />
						<xsl:choose>
							<xsl:when test="../../portal:parameter[base:name='type']/base:value='internal'">
								<xsl:variable name="layout-element-ref" select="//portal:navigation-element[@uniqueName=$url]/@layout-element-ref" />
								<xsl:choose>
									<xsl:when test="$layout-element-ref">
										<xsl:choose>
											<xsl:when test="//portal:layout-element[@uniqueName=$layout-element-ref]/portal:parameter[base:name='objectid']">
												<xsl:value-of select="//portal:layout-element[@uniqueName=$layout-element-ref]/portal:parameter[base:name='objectid']/base:value"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$layout-element-ref" />
											</xsl:otherwise>
										</xsl:choose>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$url" />
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$url" />
							</xsl:otherwise>
						</xsl:choose>
					</supported-markup>
				</xsl:when>
				<xsl:otherwise>
					<!-- supported-markup -->
					<supported-markup>
						<!-- @markup -->
						<xsl:attribute name="markup">
							<xsl:value-of select="$markup" />
						</xsl:attribute>
						<!-- @update -->
						<xsl:attribute name="update">
							<xsl:value-of select="'set'" />
						</xsl:attribute>
					</supported-markup>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>

	<!-- derivation-parentref -->
	<xsl:template name="derivation-parentref">
		<xsl:variable name="derivation-parentref" select="portal:parameter[base:name='derivation-parentref']/base:value"/>
		<xsl:if test="$derivation-parentref">
			<xsl:attribute name="derivation-parentref">
				<xsl:call-template name="layout-element-ref">
					<xsl:with-param name="ref" select="$derivation-parentref" />
				</xsl:call-template>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>
	
	<!-- shareable -->
	<xsl:template name="shareable">
		<xsl:variable name="shareable" select="portal:parameter[base:name='shareable']/base:value" />
		<xsl:if test="$shareable">
			<xsl:attribute name="shareable">
				<xsl:value-of select="$shareable" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>
	
	<!-- allportletsallowed -->
	<xsl:template name="allportletsallowed">
		<xsl:variable name="allportletsallowed" select="portal:parameter[base:name='allportletsallowed']/base:value" />
		<xsl:if test="$allportletsallowed">
			<xsl:attribute name="allportletsallowed">
				<xsl:value-of select="$allportletsallowed" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>
	
	<!-- allowed-portlet -->
	<xsl:template name="allowed-portlet">
		<xsl:for-each select="base:value">
			<xsl:variable name="allowed-portlet" select="."/>
			<xsl:variable name="allowed-portlet-ref">
				<xsl:choose>
					<xsl:when test="$localportlet-xml">
						<xsl:variable name="localportlet-list">
							<xsl:for-each select="document($localportlet-xml)/uteportlets/portlet">
								<xsl:value-of select="concat(';', @portlet-name, ';')" />
							</xsl:for-each>
						</xsl:variable>
						<xsl:variable name="portlet-name" select="//portal:application-element[@uniqueName=$allowed-portlet]/portal:parameter[base:name='portlet-name']/base:value" />
						<xsl:choose>
							<xsl:when test="contains($localportlet-list, concat(';', $portlet-name, ';'))">
								<xsl:call-template name="application-element-ref">
									<xsl:with-param name="ref" select="$allowed-portlet" />
								</xsl:call-template>
							</xsl:when>
							<xsl:otherwise>
								<xsl:if test="$dummyportlet-portlet-name">
									<xsl:value-of select="concat('OID_', translate($dummyportlet-portlet-name, ' ', '_'))" />
								</xsl:if>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:call-template name="application-element-ref">
							<xsl:with-param name="ref" select="$allowed-portlet" />
						</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="not($allowed-portlet-ref='undefined')">
				<!-- allowed-portlet -->
				<allowed-portlet>
					<!-- @portlet -->
					<xsl:attribute name="portlet">
						<xsl:value-of select="$allowed-portlet-ref" />
					</xsl:attribute>
					<!-- @update -->
					<xsl:attribute name="update">
						<xsl:value-of select="'set'" />
					</xsl:attribute>
				</allowed-portlet>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

	<!-- bookmarkable -->
	<xsl:template name="bookmarkable">
		<parameter>
			<xsl:attribute name="name">
				<xsl:value-of select="'bookmarkable'" />
			</xsl:attribute>	
			<xsl:attribute name="type">
				<xsl:value-of  select="'string'" />
			</xsl:attribute>	
			<xsl:attribute name="update">
				<xsl:value-of  select="'set'" />
			</xsl:attribute>	
			<xsl:variable name="bookmarkable" select="base:value"/>
			<xsl:choose>
				<xsl:when test="$bookmarkable='true'">
					<xsl:value-of select="'Yes'"/>
				</xsl:when>
				<xsl:when test="$bookmarkable='false'">
					<xsl:value-of select="'No'"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'No'"/>
				</xsl:otherwise>
			</xsl:choose>
		</parameter>
	</xsl:template>

	<!-- deletable -->
	<xsl:template name="deletable">
		<xsl:variable name="deletable" select="portal:parameter[base:name='deletable']/base:value" />
		<xsl:if test="$deletable">
			<xsl:attribute name="deletable">
				<xsl:value-of select="$deletable" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- modifiable -->
	<xsl:template name="modifiable">
		<xsl:variable name="modifiable" select="portal:parameter[base:name='modifiable']/base:value" />
		<xsl:if test="$modifiable">
			<xsl:attribute name="modifiable">
				<xsl:value-of select="$modifiable" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- movable -->
	<xsl:template name="movable">
		<xsl:variable name="movable" select="portal:parameter[base:name='movable']/base:value" />
		<xsl:if test="$movable">
			<xsl:attribute name="movable">
				<xsl:value-of select="$movable" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- nestable -->
	<xsl:template name="nestable">
		<xsl:variable name="nestable" select="portal:parameter[base:name='nestable']/base:value" />
		<xsl:if test="$nestable">
			<xsl:attribute name="nestable">
				<xsl:value-of select="$nestable" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- shadowref -->
	<xsl:template name="shadowref">
		<xsl:variable name="shadowref" select="portal:parameter[base:name='shadowref']/base:value" />
		<xsl:if test="$shadowref">
			<xsl:attribute name="shadowref">
				<xsl:call-template name="container-window-ref">
					<xsl:with-param name="ref" select="$shadowref" />
				</xsl:call-template>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- shadow-parentref -->
	<xsl:template name="shadow-parentref">
		<xsl:variable name="shadow-parentref" select="portal:parameter[base:name='shadow-parentref']/base:value" />
		<xsl:if test="$shadow-parentref">
			<xsl:attribute name="shadow-parentref">
				<xsl:call-template name="container-window-ref">
					<xsl:with-param name="ref" select="$shadow-parentref" />
				</xsl:call-template>
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- application-element-ref -->
	<xsl:template name="application-element-ref">
		<xsl:param name="ref" />
		<xsl:choose>
			<xsl:when test="$ref and string-length($ref)&gt;0">
				<xsl:choose>
					<xsl:when test="$ref='undefined'">
						<xsl:value-of select="'undefined'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="application-element" select="//portal:application-element[@uniqueName=$ref]" />
						<xsl:choose>
							<xsl:when test="$application-element">
								<xsl:variable name="application-element-objectid" select="$application-element/portal:parameter[base:name='objectid']/base:value" />
								<xsl:choose>
									<xsl:when test="$application-element-objectid and string-length($application-element-objectid)&gt;0">
										<xsl:value-of select="$application-element-objectid" />
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('OID_', translate($ref, ' ', '_'))" />
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'undefined'" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'undefined'" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- layout-element-ref -->
	<xsl:template name="layout-element-ref">
		<xsl:param name="ref" />
		<xsl:choose>
			<xsl:when test="$ref and string-length($ref)&gt;0">
				<xsl:choose>
					<xsl:when test="$ref='undefined'">
						<xsl:value-of select="'undefined'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="layout-element" select="//portal:layout-element[@uniqueName=$ref]" />
						<xsl:choose>
							<xsl:when test="$layout-element">
								<xsl:variable name="layout-element-objectid" select="$layout-element/portal:parameter[base:name='objectid']/base:value" />
								<xsl:choose>
									<xsl:when test="$layout-element-objectid and string-length($layout-element-objectid)&gt;0">
										<xsl:value-of select="$layout-element-objectid" />
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('OID_', translate($ref, ' ', '_'))" />
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'undefined'" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'undefined'" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- container-window-ref -->
	<xsl:template name="container-window-ref">
		<xsl:param name="ref" />
		<xsl:choose>
			<xsl:when test="$ref and string-length($ref)&gt;0">
				<xsl:choose>
					<xsl:when test="$ref='undefined'">
						<xsl:value-of select="'undefined'" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:variable name="container" select="//portal:container[@uniqueName=$ref]" />
						<xsl:variable name="window" select="//portal:window[@uniqueName=$ref]" />
						<xsl:choose>
							<xsl:when test="$container">
								<xsl:variable name="container-objectid" select="$container/portal:parameter[base:name='objectid']/base:value" />
								<xsl:choose>
									<xsl:when test="$container-objectid and string-length($container-objectid)&gt;0">
										<xsl:value-of select="$container-objectid" />
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('OID_', translate($ref, ' ', '_'))" />
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:when test="$window">
								<xsl:variable name="window-objectid" select="$window/portal:parameter[base:name='objectid']/base:value" />
								<xsl:choose>
									<xsl:when test="$window-objectid and string-length($window-objectid)&gt;0">
										<xsl:value-of select="$window-objectid" />
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="concat('OID_', translate($ref, ' ', '_'))" />
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'undefined'" />
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'undefined'" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- @default -->
	<xsl:template name="default">
		<xsl:if test="portal:parameter[base:name='default']">
			<xsl:attribute name="default">
				<xsl:value-of select="portal:parameter[base:name='default']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @resourceroot -->
	<xsl:template name="resourceroot">
		<xsl:if test="portal:parameter[base:name='resourceroot']">
			<xsl:attribute name="resourceroot">
				<xsl:value-of select="portal:parameter[base:name='resourceroot']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @ordinal -->
	<xsl:template name="ordinal">
		<xsl:if test="portal:parameter[base:name='ordinal']">
			<xsl:attribute name="ordinal">
				<xsl:value-of select="portal:parameter[base:name='ordinal']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @width -->
	<xsl:template name="width">
		<xsl:if test="portal:parameter[base:name='width']">
			<xsl:attribute name="width">
				<xsl:value-of select="portal:parameter[base:name='width']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- @label -->
	<xsl:template name="label">
		<xsl:if test="portal:parameter[base:name='label']">
			<xsl:attribute name="label">
				<xsl:value-of select="portal:parameter[base:name='label']/base:value" />
			</xsl:attribute>
		</xsl:if>
	</xsl:template>

	<!-- Identity transformation template -->
	<xsl:template match="*|@*|comment()|processing-instruction()|text()">
		<xsl:copy>
			<xsl:apply-templates select="*|@*|comment()|processing-instruction()|text()" />
		</xsl:copy>
	</xsl:template>
</xsl:stylesheet>
